/* Actions (message types) */
mtype = { nop, a12, a22, a5, a24, a19, a18, a21, a3, a9, a20, a23, a16, a17, a1, a32, a28, a4, a30, a15, a29, a7, a6, a14, a31, a27, a25, a10, a2, a11, a8, a13, a26 };

/* Inter-process channels */
chan p7_6 = [0] of {mtype};
chan p6_5 = [0] of {mtype};
chan p6_4 = [0] of {mtype};
chan p7_2 = [0] of {mtype};
chan p7_1 = [0] of {mtype};
chan p3_1 = [0] of {mtype};
chan p5_0 = [0] of {mtype};

/* Environement<->process channels */
chan p7 = [0] of {mtype};
chan p6 = [0] of {mtype};
chan p5 = [0] of {mtype};
chan p4 = [0] of {mtype};
chan p3 = [0] of {mtype};
chan p2 = [0] of {mtype};
chan p1 = [0] of {mtype};
chan p0 = [0] of {mtype};

/* Environment process */
active proctype Environment()
{
  do
  :: p7 ! a12
  :: p6 ! a22
  :: p6 ! a5
  :: p6 ! a24
  :: p6 ! a18
  :: p6 ! a3
  :: p5 ! a9
  :: p6 ! a1
  :: p4 ! a32
  :: p4 ! a28
  :: p6 ! a4
  :: p4 ! a30
  :: p4 ! a29
  :: p4 ! a31
  :: p6 ! a2
  :: p7 ! nop
  :: p6 ! nop
  :: p5 ! nop
  :: p4 ! nop
  :: p3 ! nop
  :: p2 ! nop
  :: p1 ! nop
  :: p0 ! nop
  od
}

/* Action channel */
chan act = [0] of {mtype};

/* Most recent message event */
mtype lastAction = nop;

/* Action listener */
active proctype Listener()
{
  atomic {
    do
    :: act ? lastAction ->
  step: skip
    od
  }
}

/* Process 0 */
active proctype Proc0()
{
  int state = 8;
  do
  :: state == 8 ->
    atomic {
      if
      :: p0 ? nop ->

        state = 4;
      fi
    }
  :: state == 4 ->
    atomic {
      if
      :: p5_0 ? a13 ->
        act ! a13;
        state = 2;
      :: p5_0 ? a10 ->
        act ! a10;
        state = 3;
      fi
    }
  :: state == 3 ->
    atomic {
      if
      :: p5_0 ? a8 ->
        act ! a8;
        state = 1;
      :: p5_0 ? a10 ->
        act ! a10;
        state = 2;
      fi
    }
  :: state == 1 ->
    atomic {
      if
      :: p5_0 ? a13 ->
        act ! a13;
        state = 7;
      :: p5_0 ? a10 ->
        act ! a10;
        state = 2;
      fi
    }
  :: state == 7 ->
    atomic {
      if
      :: p5_0 ? a10 ->
        act ! a10;
        state = 6;
      :: p5_0 ? a13 ->
        act ! a13;
        state = 2;
      fi
    }
  :: state == 6 ->
    atomic {
      if
      :: p5_0 ? a8 ->
        act ! a8;
        state = 5;
      :: p5_0 ? a10 ->
        act ! a10;
        state = 2;
      fi
    }
  :: state == 5 ->
    atomic {
      if
      :: p5_0 ? a10 ->
        act ! a10;
        state = 2;
      :: p5_0 ? a13 ->
        act ! a13;
        state = 4;
      :: p5_0 ? a8 ->
        act ! a8;
        state = 2;
      fi
    }
  od
}

/* Process 1 */
active proctype Proc1()
{
  int state = 31;
  do
  :: state == 31 ->
    atomic {
      if
      :: p1 ? nop ->

        state = 29;
      fi
    }
  :: state == 29 ->
    atomic {
      if
      :: p7_1 ? a11 ->
        act ! a11;
        state = 23;
      :: p7_1 ? a14 ->
        act ! a14;
        state = 25;
      fi
    }
  :: state == 23 ->
    atomic {
      if
      :: p3_1 ? a25 ->
        act ! a25;
        state = 22;
      fi
    }
  :: state == 25 ->
    atomic {
      if
      :: p3_1 ? a25 ->
        act ! a25;
        state = 24;
      fi
    }
  :: state == 22 ->
    atomic {
      if
      :: p3_1 ? a26 ->
        act ! a26;
        state = 21;
      :: p3_1 ? a27 ->
        act ! a27;
        state = 30;
      fi
    }
  :: state == 24 ->
    atomic {
      if
      :: p3_1 ? a26 ->
        act ! a26;
        state = 16;
      fi
    }
  :: state == 21 ->
    atomic {
      if
      :: p3_1 ? a27 ->
        act ! a27;
        state = 17;
      fi
    }
  :: state == 30 ->
    atomic {
      if
      :: p3_1 ? a25 ->
        act ! a25;
        state = 30;
      :: p3_1 ? a27 ->
        act ! a27;
        state = 30;
      :: p7_1 ? a11 ->
        act ! a11;
        state = 30;
      fi
    }
  :: state == 16 ->
    atomic {
      if
      :: p3_1 ? a27 ->
        act ! a27;
        state = 28;
      fi
    }
  :: state == 17 ->
    atomic {
      if
      :: p7_1 ? a11 ->
        act ! a11;
        state = 23;
      fi
    }
  :: state == 28 ->
    atomic {
      if
      :: p7_1 ? a14 ->
        act ! a14;
        state = 23;
      :: p7_1 ? a11 ->
        act ! a11;
        state = 26;
      fi
    }
  :: state == 26 ->
    atomic {
      if
      :: p3_1 ? a25 ->
        act ! a25;
        state = 27;
      fi
    }
  :: state == 27 ->
    atomic {
      if
      :: p3_1 ? a26 ->
        act ! a26;
        state = 11;
      fi
    }
  :: state == 11 ->
    atomic {
      if
      :: p3_1 ? a27 ->
        act ! a27;
        state = 15;
      fi
    }
  :: state == 15 ->
    atomic {
      if
      :: p7_1 ? a14 ->
        act ! a14;
        state = 10;
      fi
    }
  :: state == 10 ->
    atomic {
      if
      :: p3_1 ? a25 ->
        act ! a25;
        state = 13;
      fi
    }
  :: state == 13 ->
    atomic {
      if
      :: p3_1 ? a26 ->
        act ! a26;
        state = 14;
      fi
    }
  :: state == 14 ->
    atomic {
      if
      :: p3_1 ? a27 ->
        act ! a27;
        state = 19;
      fi
    }
  :: state == 19 ->
    atomic {
      if
      :: p7_1 ? a11 ->
        act ! a11;
        state = 12;
      fi
    }
  :: state == 12 ->
    atomic {
      if
      :: p3_1 ? a25 ->
        act ! a25;
        state = 9;
      fi
    }
  :: state == 9 ->
    atomic {
      if
      :: p3_1 ? a26 ->
        act ! a26;
        state = 20;
      fi
    }
  :: state == 20 ->
    atomic {
      if
      :: p3_1 ? a27 ->
        act ! a27;
        state = 18;
      fi
    }
  :: state == 18 ->
    atomic {
      if
      :: p7_1 ? a14 ->
        act ! a14;
        state = 10;
      fi
    }
  od
}

/* Process 2 */
active proctype Proc2()
{
  int state = 36;
  do
  :: state == 36 ->
    atomic {
      if
      :: p2 ? nop ->

        state = 35;
      fi
    }
  :: state == 35 ->
    atomic {
      if
      :: p7_2 ? a6 ->
        act ! a6;
        state = 34;
      fi
    }
  :: state == 34 ->
    atomic {
      if
      :: p7_2 ? a6 ->
        act ! a6;
        state = 33;
      :: p7_2 ? a7 ->
        act ! a7;
        state = 32;
      fi
    }
  :: state == 33 ->
    atomic {
      if
      :: p7_2 ? a6 ->
        act ! a6;
        state = 33;
      fi
    }
  :: state == 32 ->
    atomic {
      if
      :: p7_2 ? a6 ->
        act ! a6;
        state = 34;
      fi
    }
  od
}

/* Process 3 */
active proctype Proc3()
{
  int state = 45;
  do
  :: state == 45 ->
    atomic {
      if
      :: p3 ? nop ->

        state = 40;
      fi
    }
  :: state == 40 ->
    atomic {
      if
      :: p3_1 ! a25 ->

        state = 39;
      :: p3_1 ! a27 ->

        state = 38;
      fi
    }
  :: state == 39 ->
    atomic {
      if
      :: p3_1 ! a26 ->

        state = 37;
      :: p3_1 ! a25 ->

        state = 38;
      fi
    }
  :: state == 38 ->
    atomic {
      if
      :: p3_1 ! a27 ->

        state = 38;
      :: p3_1 ! a26 ->

        state = 38;
      fi
    }
  :: state == 37 ->
    atomic {
      if
      :: p3_1 ! a27 ->

        state = 44;
      fi
    }
  :: state == 44 ->
    atomic {
      if
      :: p3_1 ! a25 ->

        state = 43;
      fi
    }
  :: state == 43 ->
    atomic {
      if
      :: p3_1 ! a26 ->

        state = 42;
      fi
    }
  :: state == 42 ->
    atomic {
      if
      :: p3_1 ! a25 ->

        state = 38;
      :: p3_1 ! a27 ->

        state = 41;
      :: p3_1 ! a26 ->

        state = 38;
      fi
    }
  :: state == 41 ->
    atomic {
      if
      :: p3_1 ! a25 ->

        state = 43;
      :: p3_1 ! a27 ->

        state = 38;
      fi
    }
  od
}

/* Process 4 */
active proctype Proc4()
{
  int state = 64;
  do
  :: state == 64 ->
    atomic {
      if
      :: p4 ? nop ->

        state = 54;
      fi
    }
  :: state == 54 ->
    atomic {
      if
      :: p6_4 ? a16 ->
        act ! a16;
        state = 61;
      :: p6_4 ? a17 ->
        act ! a17;
        state = 63;
      fi
    }
  :: state == 61 ->
    atomic {
      if
      :: p4 ? a28 ->
        act ! a28;
        state = 62;
      fi
    }
  :: state == 63 ->
    atomic {
      if
      :: p4 ? a28 ->
        act ! a28;
        state = 59;
      fi
    }
  :: state == 62 ->
    atomic {
      if
      :: p4 ? a29 ->
        act ! a29;
        state = 56;
      fi
    }
  :: state == 59 ->
    atomic {
      if
      :: p4 ? a29 ->
        act ! a29;
        state = 57;
      fi
    }
  :: state == 56 ->
    atomic {
      if
      :: p4 ? a30 ->
        act ! a30;
        state = 48;
      fi
    }
  :: state == 57 ->
    atomic {
      if
      :: p4 ? a30 ->
        act ! a30;
        state = 55;
      fi
    }
  :: state == 48 ->
    atomic {
      if
      :: p4 ? a31 ->
        act ! a31;
        state = 50;
      fi
    }
  :: state == 55 ->
    atomic {
      if
      :: p4 ? a31 ->
        act ! a31;
        state = 47;
      fi
    }
  :: state == 50 ->
    atomic {
      if
      :: p4 ? a32 ->
        act ! a32;
        state = 53;
      fi
    }
  :: state == 47 ->
    atomic {
      if
      :: p4 ? a32 ->
        act ! a32;
        state = 54;
      fi
    }
  :: state == 53 ->
    atomic {
      if
      :: p6_4 ? a16 ->
        act ! a16;
        state = 52;
      :: p6_4 ? a15 ->
        act ! a15;
        state = 63;
      fi
    }
  :: state == 52 ->
    atomic {
      if
      :: p4 ? a28 ->
        act ! a28;
        state = 51;
      fi
    }
  :: state == 51 ->
    atomic {
      if
      :: p4 ? a29 ->
        act ! a29;
        state = 58;
      fi
    }
  :: state == 58 ->
    atomic {
      if
      :: p4 ? a30 ->
        act ! a30;
        state = 60;
      fi
    }
  :: state == 60 ->
    atomic {
      if
      :: p4 ? a31 ->
        act ! a31;
        state = 46;
      fi
    }
  :: state == 46 ->
    atomic {
      if
      :: p4 ? a32 ->
        act ! a32;
        state = 49;
      fi
    }
  :: state == 49 ->
    atomic {
      if
      :: p6_4 ? a15 ->
        act ! a15;
        state = 52;
      :: p6_4 ? a16 ->
        act ! a16;
        state = 52;
      fi
    }
  od
}

/* Process 5 */
active proctype Proc5()
{
  int state = 80;
  do
  :: state == 80 ->
    atomic {
      if
      :: p5 ? nop ->

        state = 72;
      fi
    }
  :: state == 72 ->
    atomic {
      if
      :: p6_5 ? a23 ->
        act ! a23;
        state = 71;
      fi
    }
  :: state == 71 ->
    atomic {
      if
      :: p5_0 ! a10 ->

        state = 78;
      fi
    }
  :: state == 78 ->
    atomic {
      if
      :: p5_0 ! a8 ->

        state = 79;
      fi
    }
  :: state == 79 ->
    atomic {
      if
      :: p5 ? a9 ->
        act ! a9;
        state = 66;
      fi
    }
  :: state == 66 ->
    atomic {
      if
      :: p5_0 ! a13 ->

        state = 68;
      fi
    }
  :: state == 68 ->
    atomic {
      if
      :: p6_5 ? a23 ->
        act ! a23;
        state = 70;
      :: p6_5 ? a21 ->
        act ! a21;
        state = 73;
      fi
    }
  :: state == 70 ->
    atomic {
      if
      :: p5_0 ! a10 ->

        state = 76;
      fi
    }
  :: state == 73 ->
    atomic {
      if
      :: p5_0 ! a10 ->

        state = 75;
      fi
    }
  :: state == 76 ->
    atomic {
      if
      :: p5_0 ! a8 ->

        state = 65;
      fi
    }
  :: state == 75 ->
    atomic {
      if
      :: p5_0 ! a8 ->

        state = 69;
      fi
    }
  :: state == 65 ->
    atomic {
      if
      :: p5 ? a9 ->
        act ! a9;
        state = 77;
      fi
    }
  :: state == 69 ->
    atomic {
      if
      :: p5 ? a9 ->
        act ! a9;
        state = 67;
      fi
    }
  :: state == 77 ->
    atomic {
      if
      :: p5_0 ! a13 ->

        state = 74;
      fi
    }
  :: state == 67 ->
    atomic {
      if
      :: p5_0 ! a13 ->

        state = 72;
      fi
    }
  :: state == 74 ->
    atomic {
      if
      :: p6_5 ? a23 ->
        act ! a23;
        state = 70;
      fi
    }
  od
}

/* Process 6 */
active proctype Proc6()
{
  int state = 94;
  do
  :: state == 94 ->
    atomic {
      if
      :: p6 ? nop ->

        state = 84;
      fi
    }
  :: state == 84 ->
    atomic {
      if
      :: p6_5 ! a23 ->

        state = 83;
      :: p6_4 ! a16 ->

        state = 92;
      fi
    }
  :: state == 83 ->
    atomic {
      if
      :: p6 ? a22 ->
        act ! a22;
        state = 89;
      fi
    }
  :: state == 92 ->
    atomic {
      if
      :: p6 ? a5 ->
        act ! a5;
        state = 88;
      :: p6_4 ! a15 ->

        state = 91;
      fi
    }
  :: state == 89 ->
    atomic {
      if
      :: p6 ? a18 ->
        act ! a18;
        state = 85;
      :: p7_6 ? a20 ->
        act ! a20;
        state = 90;
      :: p6_5 ! a21 ->

        state = 86;
      fi
    }
  :: state == 88 ->
    atomic {
      if
      :: p6 ? a4 ->
        act ! a4;
        state = 87;
      fi
    }
  :: state == 91 ->
    atomic {
      if
      :: p6 ? a3 ->
        act ! a3;
        state = 84;
      fi
    }
  :: state == 85 ->
    atomic {
      if
      :: p6_4 ! a17 ->

        state = 89;
      fi
    }
  :: state == 90 ->
    atomic {
      if
      :: p7_6 ? a19 ->
        act ! a19;
        state = 89;
      fi
    }
  :: state == 86 ->
    atomic {
      if
      :: p6_4 ! a15 ->

        state = 81;
      :: p6 ? a24 ->
        act ! a24;
        state = 84;
      fi
    }
  :: state == 87 ->
    atomic {
      if
      :: p6 ? a1 ->
        act ! a1;
        state = 93;
      fi
    }
  :: state == 81 ->
    atomic {
      if
      :: p6 ? a2 ->
        act ! a2;
        state = 81;
      :: p6 ? a3 ->
        act ! a3;
        state = 81;
      :: p6 ? a5 ->
        act ! a5;
        state = 82;
      :: p6_5 ! a21 ->

        state = 81;
      :: p6_4 ! a16 ->

        state = 81;
      :: p6_4 ! a15 ->

        state = 81;
      :: p7_6 ? a20 ->
        act ! a20;
        state = 81;
      fi
    }
  :: state == 93 ->
    atomic {
      if
      :: p6 ? a2 ->
        act ! a2;
        state = 92;
      fi
    }
  :: state == 82 ->
    atomic {
      if
      :: p6_4 ! a15 ->

        state = 82;
      :: p6_4 ! a16 ->

        state = 82;
      :: p7_6 ? a19 ->
        act ! a19;
        state = 82;
      :: p7_6 ? a20 ->
        act ! a20;
        state = 82;
      :: p6 ? a22 ->
        act ! a22;
        state = 82;
      :: p6 ? a3 ->
        act ! a3;
        state = 82;
      :: p6_5 ! a21 ->

        state = 82;
      :: p6_4 ! a17 ->

        state = 82;
      :: p6 ? a4 ->
        act ! a4;
        state = 82;
      fi
    }
  od
}

/* Process 7 */
active proctype Proc7()
{
  int state = 114;
  do
  :: state == 114 ->
    atomic {
      if
      :: p7 ? nop ->

        state = 96;
      fi
    }
  :: state == 96 ->
    atomic {
      if
      :: p7_6 ! a20 ->

        state = 99;
      fi
    }
  :: state == 99 ->
    atomic {
      if
      :: p7_1 ! a14 ->

        state = 108;
      fi
    }
  :: state == 108 ->
    atomic {
      if
      :: p7_1 ! a11 ->

        state = 111;
      fi
    }
  :: state == 111 ->
    atomic {
      if
      :: p7 ? a12 ->
        act ! a12;
        state = 95;
      fi
    }
  :: state == 95 ->
    atomic {
      if
      :: p7_2 ! a6 ->

        state = 110;
      fi
    }
  :: state == 110 ->
    atomic {
      if
      :: p7_2 ! a7 ->

        state = 107;
      fi
    }
  :: state == 107 ->
    atomic {
      if
      :: p7_6 ! a19 ->

        state = 104;
      :: p7_6 ! a20 ->

        state = 105;
      fi
    }
  :: state == 104 ->
    atomic {
      if
      :: p7_1 ! a14 ->

        state = 106;
      fi
    }
  :: state == 105 ->
    atomic {
      if
      :: p7_1 ! a14 ->

        state = 112;
      fi
    }
  :: state == 106 ->
    atomic {
      if
      :: p7_1 ! a11 ->

        state = 98;
      fi
    }
  :: state == 112 ->
    atomic {
      if
      :: p7_1 ! a11 ->

        state = 102;
      fi
    }
  :: state == 98 ->
    atomic {
      if
      :: p7 ? a12 ->
        act ! a12;
        state = 103;
      fi
    }
  :: state == 102 ->
    atomic {
      if
      :: p7 ? a12 ->
        act ! a12;
        state = 109;
      fi
    }
  :: state == 103 ->
    atomic {
      if
      :: p7_2 ! a6 ->

        state = 113;
      fi
    }
  :: state == 109 ->
    atomic {
      if
      :: p7_2 ! a6 ->

        state = 101;
      :: p7_1 ! a11 ->

        state = 97;
      fi
    }
  :: state == 113 ->
    atomic {
      if
      :: p7_2 ! a7 ->

        state = 96;
      fi
    }
  :: state == 101 ->
    atomic {
      if
      :: p7_2 ! a7 ->

        state = 100;
      fi
    }
  :: state == 97 ->
    atomic {
      if
      :: p7_2 ! a6 ->

        state = 97;
      :: p7_6 ! a20 ->

        state = 97;
      :: p7_1 ! a11 ->

        state = 97;
      :: p7_1 ! a14 ->

        state = 97;
      :: p7 ? a12 ->
        act ! a12;
        state = 97;
      fi
    }
  :: state == 100 ->
    atomic {
      if
      :: p7_6 ! a19 ->

        state = 105;
      fi
    }
  od
}

#define p_a12	 (lastAction == a12)
#define p_a22	 (lastAction == a22)
#define p_a5	 (lastAction == a5)
#define p_a24	 (lastAction == a24)
#define p_a19	 (lastAction == a19)
#define p_a18	 (lastAction == a18)
#define p_a21	 (lastAction == a21)
#define p_a3	 (lastAction == a3)
#define p_a9	 (lastAction == a9)
#define p_a20	 (lastAction == a20)
#define p_a23	 (lastAction == a23)
#define p_a16	 (lastAction == a16)
#define p_a17	 (lastAction == a17)
#define p_a1	 (lastAction == a1)
#define p_a32	 (lastAction == a32)
#define p_a28	 (lastAction == a28)
#define p_a4	 (lastAction == a4)
#define p_a30	 (lastAction == a30)
#define p_a15	 (lastAction == a15)
#define p_a29	 (lastAction == a29)
#define p_a7	 (lastAction == a7)
#define p_a6	 (lastAction == a6)
#define p_a14	 (lastAction == a14)
#define p_a31	 (lastAction == a31)
#define p_a27	 (lastAction == a27)
#define p_a25	 (lastAction == a25)
#define p_a10	 (lastAction == a10)
#define p_a2	 (lastAction == a2)
#define p_a11	 (lastAction == a11)
#define p_a8	 (lastAction == a8)
#define p_a13	 (lastAction == a13)
#define p_a26	 (lastAction == a26)


ltl p1	 { (p_a5 || p_a21) V (!p_a2 || p_a5 || p_a21 || (p_a15 V (!p_a4 || p_a15))) }
ltl p2	 { (p_a2 || p_a3) V (p_a2 || p_a3 || !p_a21) }
ltl p3	 { <>(p_a2 V (p_a2 || !p_a4)) }
ltl p4	 { (p_a3 || p_a20) V (p_a3 || !p_a19 || p_a20) }
ltl p5	 { [](!p_a5 || <>p_a2) }
ltl p6	 { p_a22 V (!p_a17 || p_a22) }
ltl p7	 { !p_a17 U (p_a3 || p_a16) }
ltl p8	 { [](!p_a23 || (p_a22 V (!p_a17 || p_a22))) }
ltl p9	 { [](!p_a23 || []!p_a20) }
ltl p10	 { [](!p_a19 || (p_a21 V (!p_a16 || p_a21))) }
ltl p11	 { (p_a15 || p_a23) V (p_a15 || p_a23 || !(p_a20 || p_a21)) }
ltl p12	 { p_a16 V (!p_a3 || p_a16 || (!p_a24 U p_a22)) }
ltl p13	 { <>(p_a22 V (!p_a20 || p_a22)) }
ltl p14	 { (p_a20 || p_a23) V (p_a20 || !p_a21 || p_a23 || []!p_a15) }
ltl p15	 { <>(p_a1 && []!p_a23) }
ltl p16	 { p_a23 V (!p_a21 || p_a23 || (!p_a5 U p_a16)) }
ltl p17	 { p_a18 V (!p_a17 || p_a18 || (p_a24 V (!p_a21 || p_a24))) }
ltl p18	 { (!p_a3 || <>p_a20) U p_a22 }
ltl p19	 { (!p_a17 || (p_a23 V (!p_a5 || p_a23))) U (p_a19 || p_a22) }
ltl p20	 { <>(p_a22 V (!p_a17 || p_a22)) }
